
#pragma once

#include "NListCtrl.h"

class CNListCtrlEx;
class INListCtrlExCallBack
{
public:
    virtual ~INListCtrlExCallBack();
    virtual BOOL OnGetItemToolTip(CNListCtrlEx* pThis, int iItem, int iSubItem, CString& strToolTip) = 0;
};

class CNListCtrlEx : public CNListCtrl
{

public:
	CNListCtrlEx(void);
	~CNListCtrlEx(void);

    void SetCallBack(INListCtrlExCallBack* pCallBack) { m_pCallBack = pCallBack; }
    void SetEnableItemToolTips(BOOL bEnable) { m_bEnableItemTips = bEnable; }
	//void    SetTrackHoverFlag(bool flag);
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnMouseHover(UINT nFlags, CPoint point);
	afx_msg void OnMouseLeave();
private:
	//void ShowWorkStatusTooltip(int nIndex);
	//void HideWorkStatusTooltip();
	//void GetImageBox( int nCol, CRect& rcBox );
	//int m_nPrevIndex;

	//int m_nImageCol;
    //BOOL m_bInited;
	BOOL m_bMouseTrack;
	//bool m_bEnableHove;
	//bool m_bshowtip;
    
    //CToolTipCtrl* m_pOldToolTips;
    //CToolTipCtrl m_ToolTips;
    INListCtrlExCallBack*   m_pCallBack;
    int m_nItem;
    int m_nSubItem;
    BOOL m_bEnableItemTips;
    void _ReCalcItemToolTip(UINT nFlags, CPoint point);
public:
    //afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
    //afx_msg void OnDestroy();
    //virtual BOOL PreTranslateMessage(MSG* pMsg);
    void _ShowTooltip(HWND hwnd, CString strToolTip);
    void _HideTooltip(HWND hWnd);

};
